
import javafx.animation.transition.FadeTransition;
import javafx.animation.transition.PauseTransition;
import javafx.animation.transition.RotateTransition;
import javafx.animation.transition.ScaleTransition;
import javafx.animation.transition.SequentialTransition;
import javafx.animation.transition.TranslateTransition;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.scene.shape.LineTo;
import javafx.scene.shape.MoveTo;
import javafx.scene.shape.Path;
import javafx.stage.Stage;
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;

var star: Node = Path {
    translateX: 100
    translateY: 100
    fill: Color.web("#FFFF33")
    stroke: null
    scaleX: 0.25
    scaleY: 0.25

    elements: [
    MoveTo { x: 0       y: -50 },
    LineTo { x: 11.803  y: -11.804 },
    LineTo { x: 50      y: -11.804 },
    LineTo { x: 19.098  y: 11.804 },
    LineTo { x: 30.902  y: 50 },
    LineTo { x: 0       y: 26.394 },
    LineTo { x: -30.902 y: 50 },
    LineTo { x: -19.098 y: 11.804 },
    LineTo { x: -50     y: -11.804 },
    LineTo { x: -11.803 y: -11.804 },
    LineTo { x: 0       y: -50 }
    ]
};

Stage {
    title: "Sequential Animation"
    scene: Scene {
        width: 200
        height: 200
        fill: Color.web("#000033")
        content: [
            star
        ]
    }
}

var seqTransition = SequentialTransition {
    // Aj[V̑ΏۂƂȂm[h
    node: star

    // V[PVɎsAj[V
    content: [
        TranslateTransition {
            duration: 2s
            fromX: 20
            fromY: 20
            toX: 180
            toY: 20
        },
        PauseTransition {
            duration: 0.5s
        },
        RotateTransition {
            duration: 1s
            fromAngle: 0
            byAngle: 360
        },
        TranslateTransition {
            duration: 2s
            fromX: 180
            fromY: 20
            toX: 180
            toY: 180
        },
        PauseTransition {
            duration: 0.5s
        },
        RotateTransition {
            duration: 1s
            fromAngle: 0
            byAngle: 360
        },
        TranslateTransition {
            duration: 2s
            fromX: 180
            fromY: 180
            toX: 20
            toY: 180
        },
        PauseTransition {
            duration: 0.5s
        },
        RotateTransition {
            duration: 1s
            fromAngle: 0
            byAngle: 360
        },
        TranslateTransition {
            duration: 2s
            fromX: 20
            fromY: 180
            toX: 20
            toY: 20
        },
        PauseTransition {
            duration: 0.5s
        },
        RotateTransition {
            duration: 1s
            fromAngle: 0
            byAngle: 360
        },
    ]
}

Timeline {
    repeatCount: Timeline.INDEFINITE
    keyFrames : [
        KeyFrame {
            time : 0s
            action : function() {
                seqTransition.playFromStart();
            }
        },
        KeyFrame {
            time : 14s
        }
    ]
}.play();
